unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.StdCtrls,
  VCLTee.TeEngine, VCLTee.Series, Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart,
  Vcl.Grids;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    StringGrid1: TStringGrid;
    NEdit: TLabeledEdit;
    NsetBtn: TButton;
    interpolationBtn: TButton;
    testdataBtn: TButton;
    XEdit: TLabeledEdit;
    Series1: TPointSeries;
    Series2: TLineSeries;
    Series3: TLineSeries;
    Series4: TLineSeries;
    Series5: TPointSeries;
    Xin_interpolation: TButton;
    RadioGroup2: TRadioGroup;
    MinxEdit: TLabeledEdit;
    MaxXEdit: TLabeledEdit;
    RadioGroup1: TRadioGroup;
    procedure testdataBtnClick(Sender: TObject);
    procedure NsetBtnClick(Sender: TObject);
    procedure interpolationBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Xin_interpolationClick(Sender: TObject);
  private
    { Private 錾 }
    procedure GridSet(Sin, Colin: integer);
    procedure FGridSet(Sin, Colin: integer);    // ObhTCYύX
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses system.Math;

type
  DArray = array of double;

var
  x, y : Darray;
  DEF     : Boolean;
  xmax, xmin, dx : double;


// ObhTCY̕ύX
procedure TForm1.GridSet(Sin, Colin: integer);    // ObhTCYύX
var                                               // f[^[s̐10
  H, W :integer;                                  // ȏ̓XN[
begin
  if (StringGrid1.ColCount = Colin) and (StringGrid1.RowCount = Sin) then exit;
  StringGrid1.ColWidths[0] := 30;
  StringGrid1.ColCount := Colin;
  StringGrid1.RowCount := Sin;
  if Sin <= 11 then                               // XgOObh̑傫ݒ
    begin                                         // Œs܂11s͂ȉ̏ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * Sin;
      W := (StringGrid1.DefaultColWidth + 1) * (Colin - 1) + 31;
      StringGrid1.ScrollBars := ssNone;           // XN[o[Ȃ
    end
    else
    begin                                         // Œs܂11s葽ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * (10 + 1);
      W := (StringGrid1.DefaultColWidth + 1) * (Colin - 1) + 31;
      StringGrid1.ScrollBars := ssVertical;       // XN[o[\
    end;
  StringGrid1.ClientWidth := W;
  StringGrid1.ClientHeight := H;
end;

// ObhŒs̐ݒ
procedure TForm1.FGridSet(Sin, Colin: integer);
var
  E : integer;
begin
  GridSet(Sin, Colin);
  for E := 1 to Sin - 1 do
      StringGrid1.Rows[E].Text := intTostr(E);
  StringGrid1.Cols[1].Text := 'x';
  StringGrid1.Cols[2].Text := 'y';
end;

// Ń@G[ N < 0
function Ninput: integer;
var
  N, ch : integer;
begin
  result := -1;
  val(Form1.Nedit.Text, N, ch);
  if ch <> 0 then begin
    application.MessageBox('N̓͂ɊԈႢL܂B','',0);
    exit;
  end;
  if N > 100 then begin
    application.MessageBox('N100ɂĉB','',0);
    exit;
  end;
  if N < 3 then begin
    application.MessageBox('N3ȏɂĉB','',0);
    exit;
  end;
  result := N;
end;

// ObhNZbg
procedure TForm1.NsetBtnClick(Sender: TObject);
var
  N : integer;
begin
  N := Ninput;
  if N < 0 then exit;
  GridSet(N + 1, 3);
end;

// x̒l`FbN x̒l邩mF l true L false
function datacheck(x :DArray; N: integer): boolean;
var
  i, j : integer;
begin
  result := true;
  for i := 0 to N - 1 do
    for j := 0 to N - 1 do begin
      if i <> j then
        if x[i] - x[j] = 0 then begin
          application.MessageBox(pchar('x' + inttostr(i+1) + '-x' + inttostr(j+1)
                                         + '[ɂȂ܂B'),'',0);
          result := false;
          exit;
        end;
    end;
  for i := 0 to N - 2 do
    if x[i] > x[i + 1] then begin
      application.MessageBox(pchar('x' + inttostr(i+1) + '>x' + inttostr(i+2)
                                    + #13#10 +'l̑傫tłB'),'',0);
      result := false;
      exit;
    end;
end;

// Qll̊֐
function f(x: double):double;
begin
  // Qllx^3x^5ō쐬ƁAԌvZnvZƂȂ̂Ō덷ł܂B
  result := 0;
  case Form1.RadioGroup2.ItemIndex of
    0 : result := x - power(x,3) / 5 + power(x,5) / 100;
    1 : result := ln(x);
    2 : result := 1 / (1 + 2 * x * x);
  end;
end;

// Qll Zbg
procedure TForm1.testdataBtnClick(Sender: TObject);
var
  N, ch : integer;
  i : integer;
  x, y : Darray;
  d, dx, minx, maxx : double;
begin
  N := Ninput;
  if N < 0 then exit;
  val(MinXedit.Text, minx, ch);
  if ch <> 0 then begin
    application.MessageBox('Minl̓͂ɊԈႢL܂B','',0);
    exit;
  end;
  val(MaxXedit.Text, maxx, ch);
  if ch <> 0 then begin
    application.MessageBox('Maxl̓͂ɊԈႢL܂B','',0);
    exit;
  end;
  if minx >= maxx then begin
    application.MessageBox('Maxl̒lMinl菬ȒlłB','',0);
    exit;
  end;

  Nedit.Text := inttostr(N);
  GridSet(N + 1, 3);
  setlength(x, N);
  setlength(y, N);
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  Series4.Clear;
  dx := (maxx - minx) / (N- 1);
  for i := Low(x) to High(x) do begin
    d   := i * dx + minx;
    if radiogroup2.ItemIndex = 1 then d := d - minx + 0.1;
    x[i] := d;
    y[i] := f(d);
  end;
  for i := 0 to N - 1 do begin
    StringGrid1.cells[1,i + 1] := floatTostr(x[i]);
    StringGrid1.cells[2,i + 1] := floatTostr(y[i]);
  end;
  DEF := True;                        // Ot\tO
  interpolationBtnClick(Nil);
end;

// lBԌvZ
function neville(d: Double; x: DArray; y: DArray): Double;
var
  w : array of array of double;
  i, j : integer;
begin
  setlength(w, high(x) + 1, high(y) + 1);
  for i := Low(x) to High(x) do w[0,i] := y[i];

  for j := 1 to High(x) do begin
    for i := Low(x) to (High(x) - j) do
            w[j,i] := w[j-1,i+1] + (w[j-1,i+1] - w[j-1,i]) * (d - x[i+j]) / (x[i+j] - x[i]);
  end;
  result := w[high(x),0];
end;

// GCgPԌvZ
function aitken(d: Double; x: DArray; y: DArray): Double;
var
  i, j : integer;
  w : DArray;
begin
  setlength(w, High(x) + 1);
  for i := Low(x) to High(x) do w[i] := y[i];
  for j := 1 to High(x) do
    for i := High(x) downto j do
      w[i] := (w[i-1] * (x[i] - d) - w[i] * (x[i-j] - d)) / (x[i] - x[i-j]);
  result := w[High(x)];
end;

// OWFԌvZ
function Lagrange( xx: double; x, y: DArray): double;
var
  i, j : integer;
  s, p : double;
begin
  s := 0;
  for i := Low(x) to High(x) do begin
    p := y[i];
    for j := Low(x) to High(x) do begin
      if i <> j then
        p := p * (xx - x[j]) / (x[i] - x[j]);
    end;
    s := s + p;
  end;
  result := s;
end;

// Obh̒lɂԌvZ
procedure TForm1.interpolationBtnClick(Sender: TObject);
var
  N, ch, i, imax : integer;
  cn : string;
  y2, y3 : double;
  xx : double;
begin
  Xin_interpolation.Enabled := False;
  N := Ninput;
  if N < 0 then exit;
  GridSet(N + 1, 3);
  setlength(x, N);
  setlength(y, N);

  for i := Low(x) to High(x) do begin
    val(StringGrid1.cells[1,i + 1], x[i], ch);
    if ch <> 0 then begin
      cn := 'x' + intTostr(i + 1) + 'ɊԈႢL܂B';
      application.MessageBox(pchar(cn),'',0);
      break;
    end;
    val(StringGrid1.cells[2,i + 1], y[i], ch);
    if ch <> 0 then begin
      cn := 'y' + intTostr(i + 1) + 'ɊԈႢL܂B';
      application.MessageBox(pchar(cn),'',0);
      break;
    end;
  end;
  if ch <> 0 then exit;
  if not datacheck(x, N) then exit;           // x̒lɏdmF

  Series1.Clear;                              // vbgl
  Series2.Clear;                              // eXgvZl
  Series3.Clear;                              // Ԓl
  Series4.Clear;                              // eXglƕԒl
  Series5.Clear;                              // w_vZl

  chart1.Title.Text.Clear;
  case radiogroup1.ItemIndex of
    0 : chart1.Title.Text.Append('Nevilles interpolation ');
    1 : chart1.Title.Text.Append('aitken interpolation');
    2 : chart1.Title.Text.Append('Lagrange interpolation');
  end;

  xmin := x[0];
  xmax := x[0];
  for i := Low(x) to High(x) do begin
    if x[i] > xmax then xmax := x[i];
    if x[i] < xmin then xmin := x[i];
    Series1.AddXY(x[i], y[i]);
  end;

  imax := (N - 1) * 20;                             // 
  dx := (xmax - xmin) / imax;
  y3 := 0;
  for i := 0 to imax do begin
    xx := i * dx + x[0];
    case radiogroup1.ItemIndex of
      0 : y3 := neville(xx, x, y);
      1 : y3 := aitken(xx, x, y);
      2 : y3 := Lagrange(xx, x, y);
    end;
    Series3.AddXY(xx, y3);
    if DEF then begin
      if radiogroup2.ItemIndex = 1 then xx := xx - xmin + 0.1;
      y2 := f(xx);
      Series2.AddXY(xx, y2);                  // eXgl
      Series4.AddXY(xx, y3 - y2);             // l l-eXgl
    end;
  end;
  DEF := False;
  Xin_interpolation.Enabled := True;
end;

// wľvZ wlxɂyԒlvZƃOt\
procedure TForm1.Xin_interpolationClick(Sender: TObject);
var
  ch, i, j : integer;
  xd, y1, y3, xx, gmin, gmax: double;
begin
  val(Xedit.Text, xd, ch);
  if ch <> 0 then begin
    application.MessageBox('xY̓͂ɊԈႢL܂B','',0);
    exit;
  end;

  Series2.Clear;                                  // eXglOt
  Series3.Clear;                                  // ԒlOt
  Series4.Clear;                                  // l
  Series5.Clear;                                  // wl_

  chart1.Title.Text.Clear;
  case radiogroup1.ItemIndex of
    0 : chart1.Title.Text.Append('Nevilles interpolation ');
    1 : chart1.Title.Text.Append('aitken interpolation');
    2 : chart1.Title.Text.Append('Lagrange interpolation');
  end;

  gmin := xmin;
  gmax := xmax;
  if xd < gmin then gmin := xd;
  if xd > gmax then gmax := xd;

  // ŏőԃOtĕ`
  i := round((gmax - gmin) / dx);
  y3 := 0;
  for j := 0 to i do begin
    xx := j * dx + gmin;
    case radiogroup1.ItemIndex of
      0 : y3 := neville(xx, x, y);
      1 : y3 := aitken(xx, x, y);
      2 : y3 := Lagrange(xx, x, y);
    end;
    Series3.AddXY(xx, y3);
  end;
  // wl_Otǉ wlxɂyԒlvZƃOt\
  y1 := 0;
  case radiogroup1.ItemIndex of
    0 : y1 := neville(xd, x, y);
    1 : y1 := aitken(xd, x, y);
    2 : y1 := Lagrange(xd, x, y);
  end;
  Series5.AddXY(xd, y1);
end;

// Obhݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  FGridSet(101, 3);                 // Œs11 + 100s2܂ōsύXĂ
                                    // ͒lNAȂ悤ɂ܂B
  GridSet(4, 3);                    // ŏ̐ݒ
end;

end.
